
(function ($) {
    $.fn.slideDown = function (duration,callback) {
        var t = this,
            duration = duration || 300;
        if (t.is(':visible')) {
            return;
        }
        t.show();
        var height = t.height();
        t.css({
            overflow: 'hidden',
            height: 0
        });
        t.animate({
            height: height
        }, duration,'ease-out',function () {
            t.css({
                display: '',
                visibility: '',
                overflow: '',
                height: '',
            });
            if (typeof callback === "function") {
                callback();
            }
        });
        
    };
    $.fn.slideUp = function (duration,callback) {
        var t = this,
            duration = duration || 300;
        if (!t.is(':visible')) {
            return;
        }
        var height = t.height();
        // 
        t.css({
            overflow: 'hidden',
            height: height
        });
        t.animate({
            height: 0
        }, duration,'ease-out',function () {
            t.css({
                height: '',
                display: 'none',
                overflow: '',
            });
            if (typeof callback === "function") {
                callback();
            }
        });
    };
    $.fn.slideToggle = function (duration,callback) {
        var t = this,
            duration = duration || 300;
        if (t.is(':visible')) {
            t.slideUp(duration);
        }else {
            t.slideDown(duration);
        }
    };

})(Zepto);

function debounce(fn,delay) {
    var timer = null;
    return function () {
        var context = this;
        var args = arguments;
        clearTimeout(timer);
        timer = setTimeout(function () {
            fn.apply(context,args);
        },delay);
    }
}

function removeDropdownList() {
    $('.dropdown-list-popup').css({
        "opacity":0
    });
    $('.dropdown-list-overlay-visible').removeClass('dropdown-list-overlay-visible');
    $(document.body).removeClass('with-dropdown-list-open');
    $('.dropdown-list-popup').remove();
}


$(document).on('click','[data-toggle="dropdownList"]',function () {
    if ($('.popup-overlay').length == 0) {
        $('.page-group').append('<div class="popup-overlay dropdown-list-overlay-visible"></div>')
    }else {
        $('.popup-overlay').addClass('dropdown-list-overlay-visible');
    }
    var listTmp = $(this).find('.dropdown-list-menu').clone().addClass('dropdown-list-popup').append('<div class="arrow"></div>');
    $('.dropdown-list-overlay-visible').after(listTmp);
    var iconH = $(this).height(),
        iconW = $(this).width(),
        top = $(this).offset().top,
        left = $(this).offset().left,
        wh = $(window).height(),
        ww = $(window).width();
    if (top > wh/2) {
        $('.dropdown-list-popup').css({
            bottom: wh - top
        }).addClass('arrow-bottom');
    }else {
        $('.dropdown-list-popup').css({
            top: top + iconH
        }).addClass('arrow-top');

    }
    if (left < 15) {
        left = 15;
    }else if(left > (ww - $('html').css('font-size').replace('px','') * 0.25 - 18 )){
        left = ww - $('html').css('font-size').replace('px','') * 0.25 - 18 ;
    }else {
        left = left + 3;
    }
    if (left < ww/2 ) {
        console.log(111);
        $('.dropdown-list-popup').css({
            right:'',
            left:0
        });
    }
    $('.dropdown-list-popup .arrow').css({
        left: left + 'px'
    });
    $('.dropdown-list-popup').show();
    $('.dropdown-list-popup').css({
        visibility:"hidden",
        overflow:"hidden"
    });
    var beforeH = $('.dropdown-list-popup').height();
    $('.dropdown-list-popup').css({
        height:0,
        width:0
    });
    $('.dropdown-list-popup').css({
        visibility:"visible",
    }).animate({
        height:beforeH,
        width:"100%",
        visibility:"",
    },200,'ease-out',function () {
        $('.dropdown-list-popup').css({
            height:"",
            width:"",
            overflow:""
        })
    });
    $(document.body).addClass('with-dropdown-list-open');
});

/*
@param  obj         当前file对象
@param  sizeLimit   图片大小限制 （单位：M）
 */
function handleFilesPreview(obj,sizeLimit) {
    var files = obj.files,
        reader = new FileReader();
    if (files[0]) {
        var size = files[0].size / 1024 / 1024;
        if (sizeLimit && size > sizeLimit) {
            $.alert('图片大小不得超过'+ sizeLimit + 'M');
            $(obj).val('');
            $(obj).next('img').remove();
            $(obj).closest('.pl-attachment-img-wrap').removeClass('has-attachment');
            return;
        }
        reader.readAsDataURL(files[0]);
        reader.onload = function () {
            if ($(obj).next('img').length == 0) {
                var img = new Image();
                img.src = this.result;
                $(obj).after(img);
                $(obj).closest('.pl-attachment-img-wrap').addClass('has-attachment');
            }else {
                $(obj).next('img').attr('src',this.result);
            }
        }

    }else {
        $(obj).next('img').remove();
        $(obj).closest('.pl-attachment-img-wrap').removeClass('has-attachment');
    }
}

$(document).on('click','.slide-down-toggle',function (e) {
    var t = $(this);
    var d = $(t.data('toggle'));
    d.slideToggle(200);
    t.find('.slide-down-toggle-icon').toggleClass('icon-packup icon-unfold');
});


$(function () {
    $(document).on('click','.dropdown-list-overlay-visible',function () {
        removeDropdownList();
    });

    $(document).on('pageInit','#DetailPageloanInfo',function (e, id, page) {
        
    });


    // 销售数据切换效果
    if ($(".content-swiper").length > 0) {

        var contentSwiper = $(".content-swiper").swiper({
            spaceBetween: 0,
        });
        if ($('.tab-swipe-nav').length > 0) {
            $('.tab-swipe-nav ul').animate({
                left: -($('.tab-swipe-nav li').index($('.tab-swipe-nav li.active')))*3 + "rem"
            });
            var i = $('.tab-swipe-nav li').index($('.tab-swipe-nav li.active'));
            contentSwiper.slideTo(i)
            contentSwiper.on('onTransitionEnd',function () {
                var i = $('.tab-swipe-nav li').index($('.tab-swipe-nav li.active'));
                var j = contentSwiper.activeIndex;
                var left;
                if (i > j) {
                    left = -(i - Math.abs(i - j))*3 + "rem"
                }else {
                    left = -(i + Math.abs(i - j))*3 + "rem"
                }
                $('.tab-swipe-nav ul').animate({
                    left: left
                },300);
                $('.tab-swipe-nav li').removeClass('active');
                $('.tab-swipe-nav li').eq(j).addClass('active');
                // $(".content").scrollTop(0);
            });

            $('.tab-swipe-nav li').on('click',function () {
                var i = $('.tab-swipe-nav li').index($('.tab-swipe-nav li.active')),
                j = $('.tab-swipe-nav li').index($(this)),l;
                if (i > j) {
                    l = -(i - Math.abs(i - j))*3 + "rem"
                }else {
                    l = -(i + Math.abs(i - j))*3 + "rem"
                }
                $('.tab-swipe-nav ul').animate({
                    left: l
                },300);
                $('.tab-swipe-nav li').removeClass('active');
                $(this).addClass('active');
                contentSwiper.slideTo(j)
            });
        
        }
        $(document).on('pageInit','#myAchievement',function (e, id, page) {
            contentSwiper.on('onTransitionEnd',function () {
                $(".content").scrollTop(0);
            });
            
        });
    }

    if ($('#content-swiper-2').length > 0) {
        var contentSwiper2 = $('#content-swiper-2').swiper({
            spaceBetween: 0
        });
        contentSwiper2.on('onTransitionEnd',function () {
            var j = contentSwiper2.activeIndex;
            $('#swiper-tab-2 > a').removeClass('active');
            $('#swiper-tab-2 > a').eq(j).addClass('active');
        });
        $('#swiper-tab-2 > a').on('click',function () {
            $('#swiper-tab-2 > a').removeClass('active');
            $(this).addClass('active');
            var i = $('#swiper-tab-2 > a').index($(this));
            contentSwiper2.slideTo(i)
        })
    }

    // 初始化
    $.init();
})

