
+ function($) {
    "use strict";
    // 格式化数据
    function getColsObject(cols,fileds){
        var values = [''];
        var names = [''];
        var result = {};
        for(var i=0;i<cols.length;i++){
            values[i]=cols[i][fileds.value];
            names[i]=cols[i][fileds.name];
        }
        result.values = values;
        result.names = names;
        return result;
    }
    // 获取默认选中值
    function getDefaultPickerValues(defaultValues,cols,fileds) {
        var result = [];
        if(!defaultValues || defaultValues.length<1 || !defaultValues[0]){
          for(var i=0;i<cols.length;i++){
                result[i] = cols[i][0][fileds.value];
          }
        }else{
            result = defaultValues;
        }
        return result;
    }
    // 获取列数据
    function getCols(cols,fileds){
        var result = [];
        for(var i=0;i<cols.length;i++){
            var formateCol = getColsObject(cols[i],fileds);
            var obj = {
                textAlign: 'center',
                values:formateCol.values,
                displayValues:formateCol.names
            };
            if(i===0) obj.cssClass="col-province";
            if(i===1) obj.cssClass="col-city";
            if(i===2) obj.cssClass="col-district";
            result[i] = obj;
        }
        return result;
    }
    // picker change 事件
    function pickerChange(picker, values, displayValues){
          var newCV1 = picker.cols[0].value;
          var newCV2;
          if(picker.params.currentValues[0] !== newCV1) {
            // 第一级数据变更
            // 获取第二级数据
            var cols2Obj = getColsObject(picker.params.getCascade(newCV1,2),picker.params.fileds);
            var cols2Values = cols2Obj.values;
            var cols2Names = cols2Obj.names;
            // 默认第二级数据
            newCV2 = cols2Values[0];
            // 刷新第二级列表
            picker.cols[1].replaceValues(cols2Values,cols2Names);
            // 设置当前值
            picker.params.currentValues[0] = newCV1;

            if(picker.cols[2]){
                // 获取第三级数据
                var cols3Obj = getColsObject(picker.params.getCascade(newCV2,3),picker.params.fileds);
                var cols3Values = cols3Obj.values;
                var cols3Names = cols3Obj.names;
                
                // 刷新第三级别表
                picker.cols[2].replaceValues(cols3Values,cols3Names);
                // 设置当前值
                picker.params.currentValues[1] = newCV2;
            }
            picker.updateValue();
            return;
          }
          newCV2 = picker.cols[1].value;
          if(picker.params.currentValues[1] !== newCV2 && picker.cols[2]) {
            // 第三级数据变更
            var cols3Obj = getColsObject(picker.params.getCascade(newCV2,3),picker.params.fileds);
            var cols3Values = cols3Obj.values;
            var cols3Names = cols3Obj.names;
            picker.cols[2].replaceValues(cols3Values,cols3Names);
            picker.params.currentValues[1] = newCV2;
            picker.updateValue();
          }
    }
    
    /**
    ** params{}
    ** fileds 默认列名
    ** cols 初始化列数据，二维数组，一列用picker就行，适用于(2-3)列
    ** pickerValues 默认选中值,如果不传则默认cols第一条数据
    ** getCasecade获取级联数据，返回json列名和fileds保持一致 ,如果不传则按初始化列数据级联
    **/
    $.fn.cascadePicker = function(params) {
        var fileds = params.fileds;
        var cols = params.cols;
        var pickerValues = getDefaultPickerValues(params.pickerValues,cols,fileds);
        var option = {
            cssClass: "city-picker",
            rotateEffect: false,
            cols: getCols(cols,fileds),
            value:pickerValues,
            toolbarTemplate:'<header class="bar bar-nav"> <button class="button button-link pull-left close-picker cancel">取消</button> <h1 class="title">请选择</h1> <button class="button button-link pull-right close-picker ok">确定</button></header>',
            formatValue:function(a,b,c){
                a.input.attr('data-code',b.join());
                return c.join('-').replace(/(\-$)/g,"");
            },
            fileds:fileds,
            currentValues:pickerValues
        }
        if (params.getCascade) {
            option.onChange = pickerChange;
            option.getCascade = params.getCascade;
        }
        $(this).picker(option);
    };

}(Zepto);
